local fontColor=Turbine.UI.Color(.8,.7,0);
local fontName=Turbine.UI.Lotro.Font.TrajanPro14;

IOWindow = class( Turbine.UI.Lotro.Window );

function IOWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );

	self:SetSize(500,500);
	self:SetPosition((Turbine.UI.Display:GetWidth()-self:GetWidth())/2, (Turbine.UI.Display:GetHeight()-self:GetHeight())/2);
	self:SetBackColor(Turbine.UI.Color(.1,.1,.1));
	self:SetText("Import/Export");
	self.ImportingDefaults=false;
	self.ImportingUpdates=false;
	self.ImportingCustom=false;
	self.DelayTime=0;

-- create bogus tabs
	self.btnImportTab=Turbine.UI.Button();
	self.btnImportTab:SetParent(self);
	self.btnImportTab:SetSize(90,20);
	self.btnImportTab:SetPosition(15,51);
	self.btnImportTab:SetBackColor(fontColor);
	self.btnImportTabLeft=Turbine.UI.Label();
	self.btnImportTabLeft:SetParent(self.btnImportTab);
	self.btnImportTabLeft:SetSize(5,20);
	self.btnImportTabLeft:SetPosition(0,0);
	self.btnImportTabLeft:SetBackground("GaranStuff/IRV/Resources/TabLeftSel.jpg")
	self.btnImportTabLeft:SetMouseVisible(false);
	self.btnImportTabCenter=Turbine.UI.Label();
	self.btnImportTabCenter:SetParent(self.btnImportTab);
	self.btnImportTabCenter:SetSize(self.btnImportTab:GetWidth()-10,20);
	self.btnImportTabCenter:SetPosition(5,1);
	self.btnImportTabCenter:SetBackColor(Turbine.UI.Color(0,0,0))
	self.btnImportTabCenter:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	self.btnImportTabCenter:SetForeColor(fontColor);
	self.btnImportTabCenter:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.btnImportTabCenter:SetText("Import");
	self.btnImportTabCenter:SetMouseVisible(false);
	self.btnImportTabRight=Turbine.UI.Label();
	self.btnImportTabRight:SetParent(self.btnImportTab);
	self.btnImportTabRight:SetSize(5,20);
	self.btnImportTabRight:SetPosition(self.btnImportTab:GetWidth()-5,0);
	self.btnImportTabRight:SetBackground("GaranStuff/IRV/Resources/TabRightSel.jpg")
	self.btnImportTabRight:SetMouseVisible(false);
	self.btnImportTab.Click=function(sender,args)
		self.btnImportTab:SetTop(51);
		self.btnImportTab:SetHeight(20);
		self.btnExportTab:SetTop(54);
		self.btnExportTab:SetHeight(16);
		self.ExportPanel:SetVisible(false);
		self.ImportPanel:SetVisible(true);
		self.ExportMessage:SetText("");
	end

	self.btnExportTab=Turbine.UI.Button();
	self.btnExportTab:SetParent(self);
	self.btnExportTab:SetSize(90,16);
	self.btnExportTab:SetPosition(self.btnImportTab:GetLeft()+self.btnImportTab:GetWidth(),54);
	self.btnExportTab:SetBackColor(fontColor);
	self.btnExportTabLeft=Turbine.UI.Label();
	self.btnExportTabLeft:SetParent(self.btnExportTab);
	self.btnExportTabLeft:SetSize(5,20);
	self.btnExportTabLeft:SetPosition(0,0);
	self.btnExportTabLeft:SetBackground("GaranStuff/IRV/Resources/TabLeftSel.jpg")
	self.btnExportTabLeft:SetMouseVisible(false);
	self.btnExportTabCenter=Turbine.UI.Label();
	self.btnExportTabCenter:SetParent(self.btnExportTab);
	self.btnExportTabCenter:SetSize(self.btnExportTab:GetWidth()-10,19);
	self.btnExportTabCenter:SetPosition(5,1);
	self.btnExportTabCenter:SetBackColor(Turbine.UI.Color(0,0,0))
	self.btnExportTabCenter:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	self.btnExportTabCenter:SetForeColor(fontColor);
	self.btnExportTabCenter:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.btnExportTabCenter:SetText("Export");
	self.btnExportTabCenter:SetMouseVisible(false);
	self.btnExportTabRight=Turbine.UI.Label();
	self.btnExportTabRight:SetParent(self.btnExportTab);
	self.btnExportTabRight:SetSize(5,20);
	self.btnExportTabRight:SetPosition(self.btnExportTab:GetWidth()-5,0);
	self.btnExportTabRight:SetBackground("GaranStuff/IRV/Resources/TabRightSel.jpg")
	self.btnExportTabRight:SetMouseVisible(false);
	self.btnExportTab.Click=function(sender,args)
		self.btnExportTab:SetTop(51);
		self.btnExportTab:SetHeight(20);
		self.btnImportTab:SetTop(54);
		self.btnImportTab:SetHeight(16);
		self.ImportPanel:SetVisible(false);
		self.ExportPanel:SetVisible(true);
		self.ImportMessage:SetText("");
	end

	self.TabPanel=Turbine.UI.Label();
	self.TabPanel:SetParent(self);
	self.TabPanel:SetSize(self:GetWidth()-30,self:GetHeight()-100);
	self.TabPanel:SetBackColor(fontColor);
	self.TabPanel:SetPosition(15,70);

	self.ImportPanel=Turbine.UI.Label();
	self.ImportPanel:SetParent(self.TabPanel);
	self.ImportPanel:SetSize(self:GetWidth()-32,self:GetHeight()-102);
	self.ImportPanel:SetBackColor(Turbine.UI.Color(0,0,0));
	self.ImportPanel:SetPosition(1,1);

	self.ImportTypeDef=Turbine.UI.Label();
	self.ImportTypeDef:SetParent(self.ImportPanel);
	self.ImportTypeDef:SetSize(110,18);
	self.ImportTypeDef:SetPosition(5,5);
	self.ImportTypeDef:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportTypeDef.Checked=false;
	self.ImportTypeDefImg=Turbine.UI.Label();
	self.ImportTypeDefImg:SetParent(self.ImportTypeDef);
	self.ImportTypeDefImg:SetSize(18,18);
	self.ImportTypeDefImg:SetPosition(0,0);
	self.ImportTypeDefImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
	self.ImportTypeDefImg:SetMouseVisible(false);
	self.ImportTypeDefCap=Turbine.UI.Label();
	self.ImportTypeDefCap:SetParent(self.ImportTypeDef);
	self.ImportTypeDefCap:SetSize(self.ImportTypeDef:GetWidth()-18,18);
	self.ImportTypeDefCap:SetPosition(18,0);
	self.ImportTypeDefCap:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportTypeDefCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ImportTypeDefCap:SetForeColor(fontColor);
	self.ImportTypeDefCap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ImportTypeDefCap:SetText("Defaults");
	self.ImportTypeDefCap:SetMouseVisible(false);
	self.ImportTypeDef.MouseClick=function(sender,args)
		self.ImportTypeDef.Checked=true;
		self.ImportTypeUpd.Checked=false;
		self.ImportTypeCust.Checked=false;
		self.ImportTypeDefImg:SetBackground("GaranStuff/IRV/Resources/RadChecked.jpg")
		self.ImportTypeUpdImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
		self.ImportTypeCustImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
		self.ImportInfo:SetText("CAUTION:\n\nThis is a destructive reset of the Image Ranges, Categories, Subcategories and Library values.  Any previously imported or custom entered values will be lost.");
		self.ImportFileCap:SetVisible(false);
		self.ImportFile:SetVisible(false);
		self.ImportMessage:SetText("");
		self.btnImport:SetVisible(true);
	end

	self.ImportTypeUpd=Turbine.UI.Label();
	self.ImportTypeUpd:SetParent(self.ImportPanel);
	self.ImportTypeUpd:SetSize(110,18);
	self.ImportTypeUpd:SetPosition(self.ImportTypeDef:GetLeft()+self.ImportTypeDef:GetWidth()+10,5);
	self.ImportTypeUpd:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportTypeUpd.Checked=true;
	self.ImportTypeUpdImg=Turbine.UI.Label();
	self.ImportTypeUpdImg:SetParent(self.ImportTypeUpd);
	self.ImportTypeUpdImg:SetSize(18,18);
	self.ImportTypeUpdImg:SetPosition(0,0);
	self.ImportTypeUpdImg:SetBackground("GaranStuff/IRV/Resources/RadChecked.jpg")
	self.ImportTypeUpdImg:SetMouseVisible(false);
	self.ImportTypeUpdCap=Turbine.UI.Label();
	self.ImportTypeUpdCap:SetParent(self.ImportTypeUpd);
	self.ImportTypeUpdCap:SetSize(self.ImportTypeUpd:GetWidth()-18,18);
	self.ImportTypeUpdCap:SetPosition(18,0);
	self.ImportTypeUpdCap:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportTypeUpdCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ImportTypeUpdCap:SetForeColor(fontColor);
	self.ImportTypeUpdCap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ImportTypeUpdCap:SetText("Updates");
	self.ImportTypeUpdCap:SetMouseVisible(false);
	self.ImportTypeUpd.MouseClick=function(sender,args)
		self.ImportTypeUpd.Checked=true;
		self.ImportTypeDef.Checked=false;
		self.ImportTypeCust.Checked=false;
		self.ImportTypeUpdImg:SetBackground("GaranStuff/IRV/Resources/RadChecked.jpg")
		self.ImportTypeDefImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
		self.ImportTypeCustImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
		self.ImportInfo:SetText("This is a non-destructive merge of the latest Update values for the Image Ranges and Library values.  In the case of a conflict between Update data and previously Imported or Custom entered data, the existing data will be preserved.  Only default values are subject to updates.");
		self.ImportFileCap:SetVisible(false);
		self.ImportFile:SetVisible(false);
		self.ImportMessage:SetText("");
		self.btnImport:SetVisible(true);
	end

	self.ImportTypeCust=Turbine.UI.Label();
	self.ImportTypeCust:SetParent(self.ImportPanel);
	self.ImportTypeCust:SetSize(110,18);
	self.ImportTypeCust:SetPosition(self.ImportTypeUpd:GetLeft()+self.ImportTypeUpd:GetWidth()+10,5);
	self.ImportTypeCust:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportTypeCust.Checked=false;
	self.ImportTypeCustImg=Turbine.UI.Label();
	self.ImportTypeCustImg:SetParent(self.ImportTypeCust);
	self.ImportTypeCustImg:SetSize(18,18);
	self.ImportTypeCustImg:SetPosition(0,0);
	self.ImportTypeCustImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
	self.ImportTypeCustImg:SetMouseVisible(false);
	self.ImportTypeCustCap=Turbine.UI.Label();
	self.ImportTypeCustCap:SetParent(self.ImportTypeCust);
	self.ImportTypeCustCap:SetSize(self.ImportTypeCust:GetWidth()-18,18);
	self.ImportTypeCustCap:SetPosition(18,0);
	self.ImportTypeCustCap:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportTypeCustCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ImportTypeCustCap:SetForeColor(fontColor);
	self.ImportTypeCustCap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ImportTypeCustCap:SetText("Custom");
	self.ImportTypeCustCap:SetMouseVisible(false);
	self.ImportTypeCust.MouseClick=function(sender,args)
		self.ImportTypeCust.Checked=true;
		self.ImportTypeDef.Checked=false;
		self.ImportTypeUpd.Checked=false;
		self.ImportTypeCustImg:SetBackground("GaranStuff/IRV/Resources/RadChecked.jpg")
		self.ImportTypeDefImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
		self.ImportTypeUpdImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
		self.ImportInfo:SetText("This is a non-destructive merge of a custom third party data file for either Image Ranges or Library values.  In the case of a conflict between Update data and previously Imported or Custom entered data, the existing data will be preserved. Only default values are subject to updates.\n\nPlease enter the custom file name.  Custom files will begin with 'EXP_' if they were created by exporting the data.  Do not include the '.plugindata' extension.");
		self.ImportFileCap:SetVisible(true);
		self.ImportFile:SetVisible(true);
-- need to uncomment the following two lines and delete the three after once Custom Imports are implemented and tested
--		self.btnImport:SetVisible(true);
--		self.ImportMessage:SetText("");
		self.btnImport:SetVisible(false);
		self.ImportMessage:SetForeColor(Turbine.UI.Color(.2,.4,1));
		self.ImportMessage:SetText("Custom Imports are not yet implemented.\n\nThis should be resolved in the next update.");
	end

	self.ImportFileCap=Turbine.UI.Label();
	self.ImportFileCap:SetParent(self.ImportPanel);
	self.ImportFileCap:SetSize(80,20);
	self.ImportFileCap:SetPosition(5,30);
	self.ImportFileCap:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportFileCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ImportFileCap:SetForeColor(fontColor);
	self.ImportFileCap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ImportFileCap:SetText("File Name:");
	self.ImportFileCap:SetVisible(false);

	self.ImportFile=Turbine.UI.TextBox();
	self.ImportFile:SetParent(self.ImportPanel);
	self.ImportFile:SetSize(280,17); -- import has to be longer because user has to include the "EXP_"
	self.ImportFile:SetPosition(self.ImportFileCap:GetWidth()+self.ImportFileCap:GetLeft(),self.ImportFileCap:GetTop());
	self.ImportFile:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft);
	self.ImportFile:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.ImportFile:SetForeColor(Turbine.UI.Color(0,0,.1));
	self.ImportFile:SetBackColor(Turbine.UI.Color(1,1,1))
	self.ImportFile:SetVisible(false);

	self.ImportInfo=Turbine.UI.Label();
	self.ImportInfo:SetParent(self.ImportPanel);
	self.ImportInfo:SetSize(self.ImportPanel:GetWidth()-20,145);
	self.ImportInfo:SetPosition(10,55);
	self.ImportInfo:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportInfo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ImportInfo:SetForeColor(fontColor);
	self.ImportInfo:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.ImportInfo:SetText("This is a non-destructive merge of the latest Update values for the Image Ranges and Library values.  In the case of a conflict between Update data and previously Imported or Custom entered data, the existing data will be preserved.  Only default values are subject to updates.");

	self.ImportMessage=Turbine.UI.Label();
	self.ImportMessage:SetParent(self.ImportPanel);
	self.ImportMessage:SetSize(self.ImportPanel:GetWidth()-20,80);
	self.ImportMessage:SetPosition(10,200);
	self.ImportMessage:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ImportMessage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ImportMessage:SetForeColor(fontColor);
	self.ImportMessage:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.ImportMessage:SetText("");

	self.btnImport=Turbine.UI.Lotro.Button();
	self.btnImport:SetParent(self.ImportPanel);
	self.btnImport:SetSize(80,20);
	self.btnImport:SetPosition((self.ImportPanel:GetWidth()-self.btnImport:GetWidth())/2, self.ImportPanel:GetHeight()-25);
	self.btnImport:SetForeColor(fontColor);
	self.btnImport:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.btnImport:SetText("Import");
	self.btnImport.Click=function(sender,args)
		if self.ImportTypeDef.Checked then
			self.DisableControls();
			self.ImportMessage:SetForeColor(Turbine.UI.Color(.7,.7,0));
			self.ImportMessage:SetText("Processing Defaults.\n\nPlease Wait.");
			self.ImportingDefaults=true;
			self.ImportingUpdates=false;
			self.ImportingCustom=false;
			self.DelayTime=Turbine.Engine.GetGameTime()+.1;
			self:SetWantsUpdates(true);
		elseif self.ImportTypeUpd.Checked then
			self.DisableControls();
			self.ImportMessage:SetForeColor(Turbine.UI.Color(.7,.7,0));
			self.ImportMessage:SetText("Processing Updates.\n\nPlease Wait.");
			self.ImportingDefaults=false;
			self.ImportingUpdates=true;
			self.ImportingCustom=false;
			self.DelayTime=Turbine.Engine.GetGameTime()+.1;
			self:SetWantsUpdates(true);
		else
			self.DisableControls();
			self.ImportMessage:SetForeColor(Turbine.UI.Color(.7,.7,0));
			self.ImportMessage:SetText("Processing Custom File.\n\nPlease Wait.");
			self.ImportingDefaults=false;
			self.ImportingUpdates=false;
			self.ImportingCustom=true;
			self.DelayTime=Turbine.Engine.GetGameTime()+.1;
			self:SetWantsUpdates(true);
		end
	end

	self.ExportPanel=Turbine.UI.Label();
	self.ExportPanel:SetParent(self.TabPanel);
	self.ExportPanel:SetSize(self:GetWidth()-32,self:GetHeight()-102);
	self.ExportPanel:SetBackColor(Turbine.UI.Color(0,0,0));
	self.ExportPanel:SetPosition(1,1);
	self.ExportPanel:SetVisible(false);

	-- for export, we only have to handle custom files
	-- we need ImageRange and Library exports (so far)

	self.ExportTypeIR=Turbine.UI.Label();
	self.ExportTypeIR:SetParent(self.ExportPanel);
	self.ExportTypeIR:SetSize(110,18);
	self.ExportTypeIR:SetPosition(5,5);
	self.ExportTypeIR:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ExportTypeIR.Checked=true;
	self.ExportTypeIRImg=Turbine.UI.Label();
	self.ExportTypeIRImg:SetParent(self.ExportTypeIR);
	self.ExportTypeIRImg:SetSize(18,18);
	self.ExportTypeIRImg:SetPosition(0,0);
	self.ExportTypeIRImg:SetBackground("GaranStuff/IRV/Resources/RadChecked.jpg")
	self.ExportTypeIRImg:SetMouseVisible(false);
	self.ExportTypeIRCap=Turbine.UI.Label();
	self.ExportTypeIRCap:SetParent(self.ExportTypeIR);
	self.ExportTypeIRCap:SetSize(self.ExportTypeIR:GetWidth()-18,18);
	self.ExportTypeIRCap:SetPosition(18,0);
	self.ExportTypeIRCap:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ExportTypeIRCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ExportTypeIRCap:SetForeColor(fontColor);
	self.ExportTypeIRCap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ExportTypeIRCap:SetText("Image Ranges");
	self.ExportTypeIRCap:SetMouseVisible(false);
	self.ExportTypeIR.MouseClick=function(sender,args)
		self.ExportTypeIR.Checked=true;
		self.ExportTypeLib.Checked=false;
		self.ExportTypeIRImg:SetBackground("GaranStuff/IRV/Resources/RadChecked.jpg")
		self.ExportTypeLibImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
		self.ExportMessage:SetText("");
	end

	self.ExportTypeLib=Turbine.UI.Label();
	self.ExportTypeLib:SetParent(self.ExportPanel);
	self.ExportTypeLib:SetSize(110,18);
	self.ExportTypeLib:SetPosition(self.ExportTypeIR:GetLeft()+self.ExportTypeIR:GetWidth()+10,self.ExportTypeIR:GetTop());
	self.ExportTypeLib:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ExportTypeLib.Checked=false;
	self.ExportTypeLibImg=Turbine.UI.Label();
	self.ExportTypeLibImg:SetParent(self.ExportTypeLib);
	self.ExportTypeLibImg:SetSize(18,18);
	self.ExportTypeLibImg:SetPosition(0,0);
	self.ExportTypeLibImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
	self.ExportTypeLibImg:SetMouseVisible(false);
	self.ExportTypeLibCap=Turbine.UI.Label();
	self.ExportTypeLibCap:SetParent(self.ExportTypeLib);
	self.ExportTypeLibCap:SetSize(self.ExportTypeLib:GetWidth()-18,18);
	self.ExportTypeLibCap:SetPosition(18,0);
	self.ExportTypeLibCap:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ExportTypeLibCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ExportTypeLibCap:SetForeColor(fontColor);
	self.ExportTypeLibCap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ExportTypeLibCap:SetText("Library");
	self.ExportTypeLibCap:SetMouseVisible(false);
	self.ExportTypeLib.MouseClick=function(sender,args)
		self.ExportTypeLib.Checked=true;
		self.ExportTypeIR.Checked=false;
		self.ExportTypeLibImg:SetBackground("GaranStuff/IRV/Resources/RadChecked.jpg")
		self.ExportTypeIRImg:SetBackground("GaranStuff/IRV/Resources/RadUnchecked.jpg")
		self.ExportMessage:SetText("");
	end

	self.ExportFileCap=Turbine.UI.Label();
	self.ExportFileCap:SetParent(self.ExportPanel);
	self.ExportFileCap:SetSize(80,20);
	self.ExportFileCap:SetPosition(5,30);
	self.ExportFileCap:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ExportFileCap:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ExportFileCap:SetForeColor(fontColor);
	self.ExportFileCap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.ExportFileCap:SetText("File Name:");

	self.ExportFile=Turbine.UI.TextBox();
	self.ExportFile:SetParent(self.ExportPanel);
	self.ExportFile:SetSize(250,17);
	self.ExportFile:SetPosition(self.ExportFileCap:GetWidth()+self.ExportFileCap:GetLeft(),self.ExportFileCap:GetTop());
	self.ExportFile:SetTextAlignment(Turbine.UI.ContentAlignment.BottomLeft);
	self.ExportFile:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.ExportFile:SetForeColor(Turbine.UI.Color(0,0,.1));
	self.ExportFile:SetBackColor(Turbine.UI.Color(1,1,1))

	self.ExportInfo=Turbine.UI.Label();
	self.ExportInfo:SetParent(self.ExportPanel);
	self.ExportInfo:SetSize(self.ExportPanel:GetWidth()-20,120);
	self.ExportInfo:SetPosition(10,55);
	self.ExportInfo:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ExportInfo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ExportInfo:SetForeColor(fontColor);
	self.ExportInfo:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.ExportInfo:SetText("Please limit File Name to 20 characters, A-Z|a-z|0-9|_ \n\nThe exported file will have a prefix of \"EXP_\" and will be saved to the PluginData folder under your username/AllServers.\n\nOnly data that you have altered will be exported. This is to help cut down on overlaps in data and custom file sizes.");

	self.ExportMessage=Turbine.UI.Label();
	self.ExportMessage:SetParent(self.ExportPanel);
	self.ExportMessage:SetSize(self.ExportPanel:GetWidth()-20,80);
	self.ExportMessage:SetPosition(10,175);
	self.ExportMessage:SetBackColor(Turbine.UI.Color(0,0,0))
	self.ExportMessage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.ExportMessage:SetForeColor(fontColor);
	self.ExportMessage:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	self.ExportMessage:SetText("");

	self.btnExport=Turbine.UI.Lotro.Button();
	self.btnExport:SetParent(self.ExportPanel);
	self.btnExport:SetSize(80,20);
	self.btnExport:SetPosition((self.ExportPanel:GetWidth()-self.btnExport:GetWidth())/2, self.ExportPanel:GetHeight()-25);
	self.btnExport:SetForeColor(fontColor);
	self.btnExport:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.btnExport:SetText("Export");
	self.btnExport.Click=function(sender,args)
		--based on radio buttons, copy the data from either ImageRanges or Library where the entries are flagged as "C" for "custom"
		local tmpData={};
		local index;
		local vindex;
		local hasError=false;
		self.ExportMessage:SetText("");
		if self.ExportTypeIR.Checked==true then
			tmpData[1]={"ImageRanges"};
			for index=1,#ImageRanges do
				if ImageRanges[index][4]=="C" then
					tmpData[#tmpData+1]={}
					for vindex=1,#ImageRanges[index] do
						tmpData[#tmpData][vindex]=ImageRanges[index][vindex];
					end
					tmpData[#tmpData][4]="I";
				end
			end
		else
			tmpData[1]={"Library"};
			for index=1,#Library do
				if Library[index][7]~=nil and Library[index][7]=="C" then
					tmpData[#tmpData+1]={};
					for vindex=1,#Library[index] do
						-- it's ok if the sub item is a table and gets the pointer, just so long as we get our own version of element [7] since we alter it
						tmpData[#tmpData][vindex]=Library[index][vindex];
					end
					tmpData[#tmpData][7]="I";
				end
			end
		end
		local fileName=self.ExportFile:GetText();
		-- verify that self.ExportFile is not blank and does not include any invalid characters or exceed 20 chars len
		local char;
		local sindex=1;
		if fileName=="" then
			hasError=true;
			self.ExportMessage:SetText("File Name is required.\n\n Export Aborted");	
		elseif string.len(fileName)>20 then
			hasError=true;
			self.ExportMessage:SetText("File Name exceeds 20 characters.\n\n Export Aborted");	
		else
			while sindex<=string.len(fileName) and not hasError do
				char=string.sub(fileName,sindex,sindex);
				if (char>="A" and char<="Z") or (char>="a" and char<="z") or (char>="0" and char<="9") or char=="_" then
					sindex=sindex+1;
				else
					hasError=true;
					self.ExportMessage:SetText("Invalid character '"..char.."' in File Name.\n\n Export Aborted");	
				end
			end
		end
		if hasError then
			self.ExportMessage:SetForeColor(Turbine.UI.Color(.7,0,0));
		else
			fileName="EXP_"..fileName
			if #tmpData==1 then
				self.ExportMessage:SetForeColor(Turbine.UI.Color(.7,0,0));
				self.ExportMessage:SetText("No Custom values found.\n\n Export Aborted");
			else
				Turbine.PluginData.Save( Turbine.DataScope.Account, fileName, tmpData );
				self.ExportMessage:SetForeColor(Turbine.UI.Color(0,.7,0));
				self.ExportMessage:SetText("Data Exported");
			end
		end
	end

	self.btnImportTab:SetZOrder(self.TabPanel:GetZOrder()+1);
	self.btnExportTab:SetZOrder(self.btnImportTab:GetZOrder()+1);

	self.DisableControls=function()
		self.btnImportTab:SetEnabled(false);
		self.btnExportTab:SetEnabled(false);
		self.ImportTypeDef:SetEnabled(false);
		self.ImportTypeUpd:SetEnabled(false);
		self.ImportTypeCust:SetEnabled(false);
		self.ExportTypeIR:SetEnabled(false);
		self.ExportTypeLib:SetEnabled(false);
		self.btnImport:SetVisible(false);
		self.btnExport:SetVisible(false);
	end
	self.EnableControls=function()
		self.btnImportTab:SetEnabled(true);
		self.btnExportTab:SetEnabled(true);
		self.ImportTypeDef:SetEnabled(true);
		self.ImportTypeUpd:SetEnabled(true);
		self.ImportTypeCust:SetEnabled(true);
		self.ExportTypeIR:SetEnabled(true);
		self.ExportTypeLib:SetEnabled(true);
		self.btnImport:SetVisible(true);
		self.btnExport:SetVisible(true);
	end
	self.Update=function()
		if self.DelayTime<Turbine.Engine.GetGameTime() then
			self.DelayTime=0;
			self:SetWantsUpdates(false);
			if self.ImportingDefaults then
				while #ImageRanges>0 do
					table.remove(ImageRanges,1);
				end
				while #Categories>0 do
					table.remove(Categories,1);
				end
				while #SubCategories>0 do
					table.remove(SubCategories,1);
				end
				while #Library>0 do
					table.remove(Library,1);
				end
				if DefaultsLoaded==nil or DefaultsLoaded==false then
					import "GaranStuff.IRV.Defaults";
				end
				LoadDefaults();
				self.ImportMessage:SetForeColor(Turbine.UI.Color(0,.7,0));
				self.ImportMessage:SetText("Default values reset");
				irvWindow:ShowBackgrounds(false);
			elseif self.ImportingUpdates then
				-- import both UpdateImageRanges and UpdateLibrary
				if UpdatesLoaded==nil or UpdatesLoaded==false then
					import "GaranStuff.IRV.Updates";
				end
				LoadUpdates();
				self.ImportMessage:SetForeColor(Turbine.UI.Color(0,.7,0));
				self.ImportMessage:SetText("Updates loaded");
				irvWindow:ShowBackgrounds(false);
			elseif self.ImportingCustom then
				-- for custom files, request the name of the file and try to import it
				-- eliminate the ".plugindata" extension if the user enters it
				-- verify that the filename starts with "EXP_" ? or do we allow users to hand build files? hmmmm
				-- verify that the first entry of the file is either {"Library"} or {"ImageRanges"}
				self.ImportMessage:SetForeColor(Turbine.UI.Color(0,.7,0));
				self.ImportMessage:SetText("Custom Import Complete.");
				irvWindow:ShowBackgrounds(false);
			end
			self:EnableControls();
		end
	end
end 
